SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell commentStamp: 'KM 6/30/2014 17:11' prior: 0!
Creating subclass SBECell!

!SBECell methodsFor: 'initialization' stamp: 'KM 6/30/2014 23:07'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!SBECell methodsFor: 'accessing' stamp: 'KM 7/2/2014 22:17'!
mouseAction: aBlock
	^mouseAction := aBlock! !

!SBECell methodsFor: 'event handling' stamp: 'KM 7/2/2014 16:57'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells logic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame methodsFor: 'initialization' stamp: 'KM 7/2/2014 22:17'!
cellsPerSide
	"The number of cells along each side of the game"
	^10! !

!SBEGame methodsFor: 'initialization' stamp: 'KM 7/2/2014 22:27'!
initialize
	|sampleCell width height n|
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @ (height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [:i :j | self newCellAt: i at: j].! !

!SBEGame methodsFor: 'initialization' stamp: 'KM 7/2/2014 22:17'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my on-screen representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^c ! !

!SBEGame methodsFor: 'gamelogic' stamp: 'KM 7/2/2014 21:34'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at:j) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j +1) toggleState].

! !
